% decide the mode of the result 
% Author(s) : Xinming Ou,Sakthiyuvaraja Sakthivelmurugan, Loai Zomlot
% Copyright (C) 2012, Argus Cybersecurity Lab, Kansas State University

% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.

% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

:-table modeJoin/3.
:-table modeMeet/3.
:-table modeJoin/4.

modeJoin(c,l,l).
modeJoin(c,p,p).
modeJoin(l,p,p).
modeJoin(u, _, u).

/* c, c -> c
   l, l -> l
   p, p -> p
   u, u -> u
*/
modeJoin(X,X,X).

/* Syemmetrical 
   c, p => p, c -> p
*/
modeJoin(X1, X2, Y) :-
	modeJoin(X2, X1, Y).

/* extend to 4 modes */

modeJoin(X1,X2,X3,Y) :-
	modeJoin(X1, X2, Y1),
	modeJoin(Y1, X3, Y).


modeMeet(c,l,c).
modeMeet(c,p,c).
modeMeet(l,p,l).
modeMeet(X,u,X).
modeMeet(X,X,X).

modeMeet(X1, X2, Y) :-
	modeMeet(X2, X1, Y).


modeSubsumes(X,X).
modeSubsumes(c, _X).
modeSubsumes(l, p).
modeSubsumes(l, u).
modeSubsumes(p, u).

modeStrengthen(l, l).
modeStrengthen(l, p).
modeStrengthen(p, l).