// Author(s) : Loai Zomlot 
// Copyright (C) 2012, Argus Cybersecurity Lab, Kansas State University

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

package core.ds;


import java.util.Comparator;

import core.utils.Utilities;

public class QueueSorter implements Comparator<DsStuff> {

	@Override
	public int compare(DsStuff o1, DsStuff o2) {

		if ((!o1.getBpaTable().keySet().isEmpty())
				&& (!o2.getBpaTable().keySet().isEmpty())) {
			double first = 1 - o1.getBpaTable().get(FrameOfDiscernment.theta);
			double second = 1 - o2.getBpaTable().get(FrameOfDiscernment.theta);

			if (first < second) {
				return 1;
			}
			if (first > second) {
				return -1;
			}
		} else {
			Utilities.print("Problem in Compination sorting!");
		}

		return 0;
	}

}
